<!DOCTYPE html>
<html lang="en">
  <head>
    <title>Task 38.40</title>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
    <link
      rel="stylesheet"
      href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
    />
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  </head>

  <body onload="onPageLoading()">
    <div class="container">
      <div class="text-center mt-3 mb-3">
        <h2>F100 - Quản trị người dùng</h2>
      </div>
      <div class="jumbotron container">
        <div class="row form-group">
          <label class="col-sm-2 col-form-label" for="firstNameInput"
            >First name</label
          >
          <div class="col-sm-3">
            <input
              type="text"
              id="firstNameInput"
              class="form-control"
              placeholder="Nhap first name ..."
            />
          </div>
          <label class="col-sm-2 col-form-label" for="lastNameInput"
            >Last name</label
          >
          <div class="col-sm-3">
            <input
              type="text"
              id="lastNameInput"
              class="form-control"
              placeholder="Nhap last name ..."
            />
          </div>
          <div class="col-sm-2">
            <button
              class="btn btn-success"
              id="btn-filter"
              onclick="onBtnFilterClick()"
            >
              Filter user
            </button>
          </div>
        </div>
      </div>
    </div>

    <div class="container mt-2">
      <div class="row">
        <div class="col-12 text-nowrap">
          <table
            id="table-users"
            class="table table-bordered table-striped table-hover"
          >
            <thead>
              <tr>
                <th>Mã người dùng</th>
                <th>Firstname</th>
                <th>Lastname</th>
                <th>Country</th>
                <th>Subject</th>
                <th>Customer Type</th>
                <th>Register Status</th>
                <th>Action</th>
              </tr>
            </thead>
            <tbody></tbody>
          </table>
        </div>
      </div>
    </div>
  </body>
  ​
  <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
      var gUsersArr = [];

      /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
      $("#btn-filter").on("click", onBtnFilterClick)

      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      /**
       * Call API để get all users và lưu vào mảng toàn cục gUsersArr.
       * gUsersArr được sử dụng cho mục đích filter về sau
      */
      // Hàm thực thi khi load trang
      function onPageLoading() {
        // gọi api load dữ liệu users
        $.ajax({
          url: 'http://203.171.20.210:8080/devcamp-register-java-api/users',
          type: 'GET',
          dataType: 'json',
          async: false, //thêm tham số async = false
          success: function (paramObjectUser) {
            gUsersArr = paramObjectUser;
          }
        });

        // gọi hàm để load dữ liệu mảng users vào table
        fillDataTableUser(gUsersArr);

      }

      //hàm xử lý sự kiện việc ấn nút fillter
      function onBtnFilterClick(params){
        "use strict"
        var vFillterObj= {
          firstname:"",
          lastname:""
        }
        //B1 thu thập dữ liệuk
        readData(vFillterObj)
        //b2 validate dữ liệu (không cần)
        //b3 thực hiện việc tìm kiếm và xử lý hiển thị
        var vArrUserFilltered =findUserByFillter(vFillterObj)
        var vtable = $("#table-users")//truy vấn dến bảng có id = "table-users"
        vtable.find("tr:gt(0)").html("")
        if(vArrUserFilltered.length>0){
          //hiển thị thông báo đã tìm được
          alert('tìm thấy'+vArrUserFilltered.length+'kết quả phù hợp')
        //Hiển thị danh sách dữ liệu tìm được ra table
        fillDataTableUser(vArrUserFilltered)
       }else{
        alert("không tìm thấy kết quả phù hợp")
        return false
       }

      }


      /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    function readData(paramKeyObj){
      "use strict"
      var vInputFirstName= $("#firstNameInput")
      var vInputLastName= $("#lastNameInput")
      paramKeyObj.firstname = $.trim(vInputFirstName.val())
      paramKeyObj.lastname = $.trim(vInputLastName.val())
    }
      /**
       * Hàm load data vào table
       * Input: mảng users
       * Output: table có dữ liệu
       */
      function fillDataTableUser(paramObjectUser) {
        var vUserTable = $('#table-users');
        for (var bI = 0; bI < paramObjectUser.length; bI++) {
          var bNewRow = $('<tr/>').appendTo(vUserTable);
          var bId = $('<td/>', {
            html: paramObjectUser[bI].id
          }).appendTo(bNewRow);

          var vFirstName = $('<td/>', {
            html: paramObjectUser[bI].firstname
          }).appendTo(bNewRow);

          var vLastName = $('<td/>', {
            html: paramObjectUser[bI].lastname
          }).appendTo(bNewRow);

          var vCountry = $('<td/>', {
            html: paramObjectUser[bI].country
          }).appendTo(bNewRow);

          var vSubject = $('<td/>', {
            html: paramObjectUser[bI].subject
          }).appendTo(bNewRow);

          var vCustomerType = $('<td/>', {
            html: paramObjectUser[bI].customerType
          }).appendTo(bNewRow);

          var vRegisterStatus = $('<td/>', {
            html: paramObjectUser[bI].registerStatus
          }).appendTo(bNewRow);

          var vAction = $('<td/>').appendTo(bNewRow);
          var vDetailButon = $("<button/>", {
            text: "Chi tiết"
          }).addClass("btn btn-primary")
            .appendTo(vAction);
        }
      }

       function findUserByFillter(paramkeyObj){
        'use strict'
        const bArrResultObj=[];
        //Kiểm tra trường hợp nếu first name vầ last name đều được nhập
        if(paramkeyObj.firstname!="" && paramkeyObj.lastname!=""){
          for(let bI = 0; bI<gUsersArr.length;bI++){
            const bItemUserObj = gUsersArr[bI];
            //thực hiện so sánh từ khóa được nhập vào dữ liệu User
            if(paramkeyObj.firstname.toLowerCase()=== bItemUserObj.firstname.toLowerCase() ||
            paramkeyObj.lastname.toLowerCase()=== bItemUserObj.lastname.toLowerCase())
            {
              bArrResultObj.push(bItemUserObj)
            }
          }
        }
        return bArrResultObj
       }
  </script>
</html>
​
